package com.blamejared.compat.botania.lexicon.pages;

import vazkii.botania.api.lexicon.LexiconPage;
import vazkii.botania.api.lexicon.LexiconEntry;
import vazkii.botania.common.lexicon.page.PageBrew;
import vazkii.botania.api.recipe.RecipeBrew;
import com.blamejared.mtlib.helpers.InputHelper;
import vazkii.botania.api.BotaniaAPI;
import crafttweaker.CraftTweakerAPI;
import com.blamejared.compat.botania.BotaniaHelper;
import crafttweaker.api.item.IIngredient;
import crafttweaker.IAction;

public class AddPageBrew implements IAction
{
    private String name;
    private String entry;
    private int page_number;
    private String brew;
    private IIngredient[] recipe;
    private String bottomText;
    
    public AddPageBrew(final String name, final String entry, final int page_number, final String brew, final IIngredient[] recipe, final String bottomText) {
        this.name = name;
        this.entry = entry;
        this.page_number = page_number;
        this.brew = brew;
        this.recipe = recipe;
        this.bottomText = bottomText;
    }
    
    public void apply() {
        final LexiconEntry lexiconEntry = BotaniaHelper.findEntry(this.entry);
        if (lexiconEntry == null) {
            CraftTweakerAPI.getLogger().logError("Cannot find lexicon entry " + this.entry);
            return;
        }
        if (this.page_number > lexiconEntry.pages.size()) {
            CraftTweakerAPI.getLogger().logError("Page Number " + this.page_number + " out of bounds for " + this.entry);
            return;
        }
        if (BotaniaAPI.getBrewFromKey(this.brew) == null) {
            CraftTweakerAPI.getLogger().logError("Cannot find brew " + this.brew);
            return;
        }
        final RecipeBrew page_recipe = new RecipeBrew(BotaniaAPI.getBrewFromKey(this.brew), InputHelper.toObjects(this.recipe));
        final LexiconPage page = (LexiconPage)new PageBrew(page_recipe, this.name, this.bottomText);
        lexiconEntry.pages.add(this.page_number, page);
    }
    
    public String describe() {
        return "Adding Lexicon Page: " + this.name;
    }
}
